## rustc-1.74 1.74.1+dfsg0ubuntu1

=== tests/run-make/allow-non-lint-warnings-cmdline/Makefile ===
# ignore-cross-compile
include ../tools.mk

# Test that -A warnings makes the 'empty trait list for derive' warning go away
OUT=$(shell $(RUSTC) foo.rs -A warnings 2>&1 | grep "warning" )

all: foo
	test -z '$(OUT)'

# This is just to make sure the above command actually succeeds
foo:
	$(RUSTC) foo.rs -A warnings

=== tests/run-make/bare-outfile/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	cp foo.rs $(TMPDIR)
	cd $(TMPDIR) && $(RUSTC) -o foo foo.rs
	$(call RUN,foo)

=== tests/run-make/codegen-options-parsing/Makefile ===
# ignore-cross-compile
include ../tools.mk

all:
	#Option taking a number
	$(RUSTC) -C codegen-units dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `codegen-units` requires a number'
	$(RUSTC) -C codegen-units= dummy.rs 2>&1 | \
		$(CGREP) 'incorrect value `` for codegen option `codegen-units` - a number was expected'
	$(RUSTC) -C codegen-units=foo dummy.rs 2>&1 | \
		$(CGREP) 'incorrect value `foo` for codegen option `codegen-units` - a number was expected'
	$(RUSTC) -C codegen-units=1 dummy.rs
	#Option taking a string
	$(RUSTC) -C extra-filename dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `extra-filename` requires a string'
	$(RUSTC) -C extra-filename= dummy.rs 2>&1
	$(RUSTC) -C extra-filename=foo dummy.rs 2>&1
	#Option taking no argument
	$(RUSTC) -C lto= dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `lto` - either a boolean (`yes`, `no`, `on`, `off`, etc), `thin`, `fat`, or omitted'
	$(RUSTC) -C lto=1 dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `lto` - either a boolean (`yes`, `no`, `on`, `off`, etc), `thin`, `fat`, or omitted'
	$(RUSTC) -C lto=foo dummy.rs 2>&1 | \
		$(CGREP) 'codegen option `lto` - either a boolean (`yes`, `no`, `on`, `off`, etc), `thin`, `fat`, or omitted'
	$(RUSTC) -C lto dummy.rs

	# Should not link dead code...
	$(RUSTC) --print link-args dummy.rs 2>&1 | \
		$(CGREP) -e '--gc-sections|-z[^ ]* [^ ]*<ignore>|-dead_strip|/OPT:REF'
	# ... unless you specifically ask to keep it
	$(RUSTC) --print link-args -C link-dead-code dummy.rs 2>&1 | \
		$(CGREP) -ve '--gc-sections|-z[^ ]* [^ ]*<ignore>|-dead_strip|/OPT:REF'

=== tests/run-make/compressed-debuginfo/Makefile ===
# ignore-cross-compile
include ../tools.mk

# only-linux
# min-llvm-version: 16.0
#
# This tests debuginfo-compression.

all: zlib zstandard

zlib:
	test "`$(RUSTC) --crate-name=foo --crate-type=lib --emit=obj -C debuginfo=full -Z debuginfo-compression=zlib foo.rs 2>&1 | sed 's/.*unknown.*zlib.*/missing/' | head -n 1`" = missing || readelf -t $(TMPDIR)/foo.o | grep -q ZLIB

zstandard:
	test "`$(RUSTC) --crate-name=foo --crate-type=lib --emit=obj -C debuginfo=full -Z debuginfo-compression=zstd foo.rs 2>&1 | sed 's/.*unknown.*zstd.*/missing/' | head -n 1`" = missing || readelf -t $(TMPDIR)/foo.o | grep -q ZST

=== tests/run-make/const_fn_mir/Makefile ===
# needs-unwind -Cpanic=abort gives different MIR output
include ../tools.mk

all:
	$(RUSTC) main.rs --emit=mir -o "$(TMPDIR)"/dump.mir

ifdef RUSTC_BLESS_TEST
	cp "$(TMPDIR)"/dump.mir dump.mir
else
	$(DIFF) dump.mir "$(TMPDIR)"/dump.mir
endif

=== tests/run-make/debugger-visualizer-dep-info/Makefile ===
include ../tools.mk

# This test makes sure that files referenced via #[debugger_visualizer] are
# included in `--emit dep-info` output.

all:
	$(RUSTC) --emit dep-info main.rs
	$(CGREP) "foo.py" < $(TMPDIR)/main.d
	$(CGREP) "my_visualizers/bar.natvis" < $(TMPDIR)/main.d

=== tests/run-make/dep-info-doesnt-run-much/Makefile ===
include ../tools.mk

all:
	$(RUSTC) foo.rs --emit dep-info

=== tests/run-make/doctests-runtool/Makefile ===
# ignore-cross-compile
include ../tools.mk

# Tests behavior of rustdoc --runtool

MY_SRC_DIR := ${CURDIR}

all: with_test_run_directory

# Behavior with --runtool with relative paths and --test-run-directory.
with_test_run_directory:
	mkdir -p $(TMPDIR)/rundir
	mkdir -p $(TMPDIR)/runtool
	$(RUSTC) --crate-type rlib t.rs
	$(RUSTC) runtool.rs -o $(TMPDIR)/runtool/runtool
	( cd $(TMPDIR); \
		$(RUSTDOC) -Zunstable-options --test --test-run-directory rundir \
			--runtool runtool/runtool --extern t=libt.rlib $(MY_SRC_DIR)/t.rs \
	)
	rm -rf $(TMPDIR)/rundir $(TMPDIR)/runtool

=== tests/run-make/extern-fn-reachable/Makefile ===
# ignore-cross-compile
include ../tools.mk

# ignore-windows-msvc

NM=nm -D

ifeq ($(UNAME),Darwin)
NM=nm -gU
endif

ifdef IS_WINDOWS
NM=nm -g
endif

# This overrides the LD_LIBRARY_PATH for RUN
TARGET_RPATH_DIR:=$(TARGET_RPATH_DIR):$(TMPDIR)

all:
	$(RUSTC) dylib.rs -o $(TMPDIR)/libdylib.so -C prefer-dynamic

	[ "$$($(NM) $(TMPDIR)/libdylib.so | grep -v __imp_ | grep -c fun1)" -eq "1" ]
	[ "$$($(NM) $(TMPDIR)/libdylib.so | grep -v __imp_ | grep -c fun2)" -eq "1" ]
	[ "$$($(NM) $(TMPDIR)/libdylib.so | grep -v __imp_ | grep -c fun3)" -eq "1" ]
	[ "$$($(NM) $(TMPDIR)/libdylib.so | grep -v __imp_ | grep -c fun4)" -eq "1" ]
	[ "$$($(NM) $(TMPDIR)/libdylib.so | grep -v __imp_ | grep -c fun5)" -eq "1" ]

=== tests/run-make/fmt-write-bloat/Makefile ===
include ../tools.mk

# ignore-windows

ifeq ($(shell $(RUSTC) -vV | grep 'host: $(TARGET)'),)

# Don't run this test when cross compiling.
all:

else

NM = nm

PANIC_SYMS = panic_bounds_check Debug

# Allow for debug_assert!() in debug builds of std.
ifdef NO_DEBUG_ASSERTIONS
PANIC_SYMS += panicking panic_fmt pad_integral Display Debug
endif

all: main.rs
	$(RUSTC) $< -O
	$(NM) $(call RUN_BINFILE,main) | $(CGREP) -v $(PANIC_SYMS)

endif

=== tests/run-make/issue-20626/Makefile ===
# ignore-cross-compile
include ../tools.mk

# Test output to be four
# The original error only occurred when printing, not when comparing using assert!

all:
	$(RUSTC) foo.rs -O
	[ `$(call RUN,foo)` = "4" ]

=== tests/run-make/issue-83112-incr-test-moved-file/Makefile ===
include ../tools.mk

# ignore-none no-std is not supported
# ignore-nvptx64-nvidia-cuda FIXME: can't find crate for 'std'

# Regression test for issue #83112
# The generated test harness code contains spans with a dummy location,
# but a non-dummy SyntaxContext. Previously, the incremental cache was encoding
# these spans as a full span (with a source file index), instead of skipping
# the encoding of the location information. If the file gest moved, the hash
# of the span will be unchanged (since it has a dummy location), so the incr
# cache would end up try to load a non-existent file using the previously
# enccoded source file id.

SRC=$(TMPDIR)/src
INCR=$(TMPDIR)/incr

all:
	mkdir $(SRC)
	mkdir $(SRC)/mydir
	mkdir $(INCR)
	cp main.rs $(SRC)/main.rs
	$(RUSTC) --test -C incremental=$(INCR) $(SRC)/main.rs --target $(TARGET)
	mv $(SRC)/main.rs $(SRC)/mydir/main.rs
	$(RUSTC) --test -C incremental=$(INCR) $(SRC)/mydir/main.rs --target $(TARGET)

=== debian/changelog ===
rustc-1.74 (1.74.1+dfsg0ubuntu1-0ubuntu13) noble; urgency=medium

  * d/rules: disable vendored source check due to hardcoded cargo.

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 03 Apr 2024 15:02:02 -0600

rustc-1.74 (1.74.1+dfsg0ubuntu1-0ubuntu12) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 03 Apr 2024 14:41:14 -0600

rustc-1.74 (1.74.1+dfsg0ubuntu1-0ubuntu10) noble; urgency=medium

  * d/control: add dh-cargo-tools to B-D.
  * d/rules: re-enable vendored source check.

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 25 Mar 2024 19:36:10 -0600

rustc-1.74 (1.74.1+dfsg0ubuntu1-0ubuntu9) noble; urgency=medium

  * d/p/ubuntu-skip-gdb-tests.patch: temporarily disables gdb tests to
    workaround test failures.

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 25 Mar 2024 19:31:09 -0600

rustc-1.74 (1.74.1+dfsg0ubuntu1-0ubuntu8) noble; urgency=medium

  * Remove upper limit for rustc b-d.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 25 Mar 2024 18:09:11 +0100

rustc-1.74 (1.74.1+dfsg0ubuntu1-0ubuntu7) noble; urgency=medium

  * Just drop the build dependency on a shared library.
  * Use an alternative for the rustc build dependency.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 25 Mar 2024 17:46:32 +0100

rustc-1.74 (1.74.1+dfsg0ubuntu1-0ubuntu5) noble; urgency=medium

  * Replace libllvm17 with libllvm17t64 in Build-Depends

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 25 Mar 2024 12:36:06 +0100

rustc-1.74 (1.74.1+dfsg0ubuntu1-0ubuntu4) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:20:45 +0000

rustc-1.74 (1.74.1+dfsg0ubuntu1-0ubuntu3) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:18:20 +0000

rustc-1.74 (1.74.1+dfsg0ubuntu1-0ubuntu2) noble; urgency=medium

  * Branch off into a version-specific source package:
    - d/control: rename all binary packages
    - d/rules: use a generator system to replace the version numbers
      dynamically
    - install all files into /usr/lib/rust-1.74/ and use versioned symlinks
    - drop the documentation package for now to make things easier
  * d/libstd-rust-X.Y: move into rustc-X.Y to avoid package name collision
  * d/libstd-rust-X.Y-dev: move into rustc-X.Y to simplify packaging

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 29 Jan 2024 09:52:43 -0700

rustc (1.74.1+dfsg0ubuntu1-0ubuntu1) noble; urgency=medium

  * New upstream release 1.74.1 (LP: #2044036)
    - d/patches: Refresh patches
    - d/p/d-0021-vendor-remove-windows-dependencies.patch: remove new
      Windows dependencies
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data and add LGPL 2.1 license texts
    - d/p/d-fix-rustix-outline.patch: re-add rustix fix for 1.74
    - d/p/ubuntu-upgrade-libgit2-to-1.7.patch: remove obsoleted patch
    - d/libstd-rust-*: bump version to 1.74
    - d/rules: apply a workaround to avoid dh_dwz complaining about
      "Too many DIEs, not optimizing"

 -- Zixing Liu <zixing.liu@canonical.com>  Sun, 19 Nov 2023 18:04:52 -0700

rustc (1.73.0+dfsg0ubuntu1-0ubuntu1) noble; urgency=medium

  * New upstream release 1.73.0 (LP: #2040340)
    - d/patches: Refresh patches
    - d/p/d-0021-vendor-remove-windows-dependencies.patch: remove new
      Windows dependencies
    - d/p/d-0020-remove-windows-dependencies.patch: remove references to macOS
      and Windows libraries in Cargo credential query logic
    - d/p/ubuntu-fix-short-ice-test.patch: remove obsoleted patch
    - d/copyright: update the list of unused crates
    - d/copyright: update copyright data
    - d/control: bump Rust toolchain B-D requirements to 1.72
    - d/control: update the list of vendored dependencies
    - d/*: bump LLVM requirements to LLVM 17
    - d/s/lintian-overrides: suppress Lintian warnings about prebuilt Windows
      binaries in libloading-0.7.4. They are required by libloading for the tests
    - d/cargo.install: remove cargo-credential-1password plugin since now this
      functionality is builtin and no longer ships as a plugin

 -- Zixing Liu <zixing.liu@canonical.com>  Tue, 24 Oct 2023 22:29:46 -0600

rustc (1.72.1+dfsg0ubuntu1-0ubuntu1) mantic; urgency=medium

  * Cherry-pick new changes from Debian until Rust 1.70 (LP: #2041325)
    Applied:
    - Disable download tests
    - Fix internal cargo-doc links
    - Fix FTCBS by setting TARGET flags
    - Update privacy breach removal
    - Update Files-Excluded and unsuspicious files
    - Remove obsoleted patches
  * d/p/u-fix-get-toml-when-test.patch: removed. This conflicts both on
    functionalities and compatibilities with other Ubuntu patches.
  * New upstream release 1.72.1 (LP: #2040339)
    - d/patches: Refresh patches
    - d/p/d-0000-ignore-removed-submodules.patch: Remove Windows-specific
      submodule
    - d/p/d-0021-vendor-remove-windows-dependencies.patch: Remove
      new Windows dependencies
    - d/p/ubuntu-fix-short-ice-test.patch: Add a patch to fix short-ice test
    - d/copyright:
      - Update copyright information for upstream patched crates
      - Update excluded dependencies list
      - Remove windows-bindgen module
    - d/control: Update vendored dependency list
    - d/control: update libgit2 B-D requirements to 1.7
    - d/s/lintian-overrides: Remove unused overrides
  * Remove fonts-nanum from the dependencies (LP: #2031685)
    - d/p/ubuntu-disable-nanum-fonts.patch: Add a patch to disable and remove
      references to the Nanum fonts. We have Noto Sans CJK in the system.
    - d/control: Remove fonts-nanum from the dependencies

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 11 Oct 2023 14:46:37 -0600

rustc (1.71.1+dfsg0ubuntu2-0ubuntu1) mantic; urgency=medium

  * Remove Windows libraries and dependencies
    (windows and windows-sys) (LP: #2036123)


=== debian/control ===
Source: rustc-1.74
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Fabian Grünbichler <debian@fabian.gruenbichler.email>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
# dh-cargo (>= 28ubuntu1~),
 dh-cargo-tools,
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo-1.74 <!pkg.rustc.dlstage0>,
 rustc-1.74 <!pkg.rustc.dlstage0>,
 llvm-17-dev:native,
 llvm-17-tools:native,
 libclang-rt-17-dev (>= 1:17.0.2),
 libclang-common-17-dev (>= 1:17.0.2),
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkg-config,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# used by cargo
 bash-completion,
 libcurl4-gnutls-dev | libcurl4-openssl-dev,
 libssh2-1-dev,
 libgit2-dev (>= 1.7.0),
 libgit2-dev (<< 1.8~~),
 libhttp-parser-dev,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 clang-17:native,
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.6.2
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The build regressed back when LTO was systematized in Ubuntu.
# This should be periodically revisited.
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
# needed for cross-compilation to avoid passing host CFLAGS to the BUILD
# compiler
export TARGET_CFLAGS = $(CFLAGS)
export TARGET_CXXFLAGS = $(CXXFLAGS)
export TARGET_CPPFLAGS = $(CPPFLAGS)
export TARGET_LDFLAGS = $(LDFLAGS)
unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
# for dh_install substitution variable
export DEB_HOST_RUST_TYPE

# for dh_install substitution variable
export RUST_LONG_VERSION
export RUST_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 17
OLD_LLVM_VERSION = 16
# used by the patched profiler build script
CLANG_RT_ARCH := $(DEB_TARGET_GNU_CPU)
ifeq (i386,$(DEB_TARGET_ARCH))
CLANG_RT_ARCH = i386
endif
ifeq (armhf,$(DEB_TARGET_ARCH))
CLANG_RT_ARCH = armhf
endif
export DEB_LLVM_VERSION = $(LLVM_VERSION)
export DEB_CLANG_RT_ARCH = $(CLANG_RT_ARCH)
# Cargo-specific flags
export LIBSSH2_SYS_USE_PKG_CONFIG=1
# Make it easier to test against a custom LLVM
ifneq (,$(LLVM_DESTDIR))
LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
export LD_LIBRARY_PATH
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH),riscv64)
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NJOBS := -j 4
endif
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/config.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := false
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

BUILD_WASM := false

BUILD_WINDOWS := false

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))

ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
  export DH_VERBOSE=1
endif

ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
  export DH_QUIET=1
.SILENT:
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/bootstrap/__pycache__ \
	src/etc/__pycache__/

# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion

.PHONY: .dbg-windows
.dbg-windows:
	@echo host=$(DEB_BUILD_ARCH) target=$(DEB_HOST_ARCH) BUILD_WINDOWS=$(BUILD_WINDOWS) WINDOWS_ARCH=$(WINDOWS_ARCH)

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion

override_dh_clean: debian/control
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

debian/preconfigure.stamp:
	for f in debian/*.in; do \
		f2=$$(echo $$f | sed 's/\.in$$//;s/X\.Y/$(RUST_VERSION)/'); \
		echo "$$f => $$f2"; \
		sed -e 's|@RUST_VERSION@|$(RUST_VERSION)|g' \
		    -e 's|@LLVM_VERSION_MAJOR@|$(LLVM_VERSION)|g' \
			$$f > $$f2; \
	done
	touch "$@"

debian/config.toml: debian/config.toml.in debian/rules debian/preconfigure.stamp
	u="$(DEB_VERSION_UPSTREAM)"; \
	if [ "$$u" != "$${u%~beta.*+dfsg*}" ]; then channel="beta"; \
	else channel="stable"; fi; \
	m4  -DRELEASE_CHANNEL="$$channel" \
		-DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
